#include "birthdeath.h"

extern gsl_rng* random_number_generator;

bool birthdeath(
		const double r_transmission,
		const double r_removal,
		const int num_particles_max,
		const int trials
		) {

	const double ratio_removed = r_removal/(r_removal+r_transmission);

	for ( int tc = 1; tc <= trials; ++tc ) {
		// Initial particle
		double t = 0.0;
		// First edges
		int num_particles = 1;
		//printf("%f\t%d\t%d\n",t,num_particles,tc);
		while (0 < num_particles && num_particles < num_particles_max) {
			double dt = gsl_ran_exponential(random_number_generator, 1.)
				/ ( (r_transmission+r_removal) * double(num_particles) ) ;
			t += dt;
			if (1==gsl_ran_bernoulli(random_number_generator,ratio_removed)) {
				--num_particles;
				//printf("%f\t%d\t%d\n",t,num_particles,tc);
			} else { 
				++num_particles;
				//printf("%f\t%d\t%d\n",t,num_particles,tc);
			} // end fission if statement
		} // end while loop
		printf("%f\t%d\t%d\n",t,num_particles,tc);
		//printf("\n");
	}
	return 0;
}
