#ifndef _MY_MATH_
#define _MY_MATH_

#include <cmath>
//#include <tgmath.h>

//Quick sorting: p and q serve as indexes into the array
//being sorted.  T is the class.  A is an array of pointers
//to the class, which has an well-ordering imposed.
template<class T> void quicksort(T* A[], long p, long r);

// This is a function internal to quicksort, and
// never should be called by itself.
template<class T> inline long partition(T* A[], long p, long r);

template<class T> inline T* max(T* a, T* b);

template<class T> inline T* min(T* a, T* b);

double magnitude(double, double);
long sign(long x);
int factorial(int x);
int gcd(int p, int q);
double nCr(double n, double r);
double binomial(double n, double r, double p);
double poisson(double x, double lambda);
double uniform_random(void);
inline int	int_random(int);
inline bool bool_random(double);
unsigned int getrandomseed(void);
// returns the solution vector in b.
void gaussian_elimination(double* A, double* b, const int n);


double heavyside(double x);

//#include "tnt/tnt.h"
//#include "tnt/cmat.h"
//#include "tnt/vec.h"

#endif
